//import org.junit.jupiter.api.Test;
//import ru.ulstu.platform.balance.boundary.BalanceEmployeeService;
//import ru.ulstu.platform.balance.entity.dto.BalanceEmployeeDto;
//import ru.ulstu.platform.balance.entity.dto.BalanceValueDto;
//import ru.ulstu.platform.tools.entity.WorkType;
//import ru.ulstu.platform.unit.entity.Unit;
//
//import java.util.Arrays;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;

//import static org.junit.jupiter.api.Assertions.assertEquals;


public class BalanceEmployeeTest {
    private final static Integer YEAR_2010 = 2010;
    private final static Integer YEAR_2011 = 2011;

//    @Test
//    public void testGetFreeEmployeesNextUnits() {
//        WorkType workType = new WorkType();
//        workType.setId(1L);
//
//        BalanceEmployeeService balanceEmployeeService = new BalanceEmployeeService();
//
//        Map<Unit, List<BalanceEmployeeDto>> allUnitBalances = new HashMap<>();
//        Unit parent = new Unit(0L);
//        Unit currentUnit = new Unit(1L);
//        currentUnit.setParent(parent);
//        Unit nextUnit = new Unit(2L);
//        nextUnit.setParent(parent);
//        Unit anotherUnit = new Unit(3L);
//        anotherUnit.setParent(parent);
//
//        parent.getChildren().addAll(Arrays.asList(currentUnit, nextUnit, anotherUnit));
//
//        Double deficit = 10.0;
//        Double proficit = deficit;
//        Double fullUseProfict = 0.0;
//
//        //move all employees (deficit == proficit)
//        BalanceValueDto balanceEmployeeValueDto = new BalanceValueDto(YEAR_2010, 1, workType, deficit * -1);
//        allUnitBalances.put(currentUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, deficit * -1)));
//        allUnitBalances.put(nextUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, proficit)));
//        Double result = balanceEmployeeService.getFreeEmployeesNextUnits(allUnitBalances, currentUnit, balanceEmployeeValueDto);
//        assertEquals(result, Double.valueOf(deficit));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(nextUnit).get(0).getMaxValue(YEAR_2010)));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(currentUnit).get(0).getMaxValue(YEAR_2010)));
//
//        //move part employees (deficit < proficit)
//        Double proficitDeficitDiff = 5.0;
//        proficit = deficit + proficitDeficitDiff;
//        allUnitBalances.put(currentUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, deficit * -1)));
//        allUnitBalances.put(nextUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, proficit)));
//        result = balanceEmployeeService.getFreeEmployeesNextUnits(allUnitBalances, currentUnit, balanceEmployeeValueDto);
//        assertEquals(result, Double.valueOf(deficit));
//        assertEquals(Double.valueOf(proficitDeficitDiff), Double.valueOf(allUnitBalances.get(nextUnit).get(0).getMaxValue(YEAR_2010)));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(currentUnit).get(0).getMaxValue(YEAR_2010)));
//
//        //move all employees and deficit not compelte (deficit > proficit)
//        proficit = deficit - proficitDeficitDiff;
//        allUnitBalances.put(currentUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, deficit * -1)));
//        allUnitBalances.put(nextUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, proficit)));
//        result = balanceEmployeeService.getFreeEmployeesNextUnits(allUnitBalances, currentUnit, balanceEmployeeValueDto);
//        assertEquals(result, Double.valueOf(deficit - proficitDeficitDiff));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(nextUnit).get(0).getMaxValue(YEAR_2010)));
//        assertEquals(Double.valueOf(proficitDeficitDiff * -1.0), Double.valueOf(allUnitBalances.get(currentUnit).get(0).getMaxValue(YEAR_2010)));
//
//        //collect from several units
//        proficit = deficit - proficitDeficitDiff;
//        allUnitBalances.put(currentUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, deficit * -1)));
//        allUnitBalances.put(nextUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, proficit)));
//        allUnitBalances.put(anotherUnit, Arrays.asList(getBalanceDto(balanceEmployeeValueDto, proficit)));
//        result = balanceEmployeeService.getFreeEmployeesNextUnits(allUnitBalances, currentUnit, balanceEmployeeValueDto);
//        assertEquals(result, Double.valueOf(deficit));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(nextUnit).get(0).getMaxValue(YEAR_2010)));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(anotherUnit).get(0).getMaxValue(YEAR_2010)));
//        assertEquals(Double.valueOf(fullUseProfict), Double.valueOf(allUnitBalances.get(currentUnit).get(0).getMaxValue(YEAR_2010)));
//    }
//
//    private BalanceEmployeeDto getBalanceDto(BalanceValueDto balanceEmployeeValueDto, double deficit) {
//        BalanceEmployeeDto dto = new BalanceEmployeeDto(BalanceEmployeeDto.BalanceEmployeeKey.DEFICIT);
//        dto.setValue(balanceEmployeeValueDto.getPeriod().getYear(), 1, balanceEmployeeValueDto.getWorkType(), deficit);
//        dto.setValue(YEAR_2011, 1, balanceEmployeeValueDto.getWorkType(), 100.0);
//        return dto;
//    }
}
